#pragma once

#include "cgp/cgp.hpp"
#include "key_positions_structure.hpp"
#include "hitbox.hpp"

using namespace cgp;

// The entire hierarchy

struct bat{
	double size;
	int hp;
	int max_hp;
	float death_time;
	bool isdead;
	vec3 pos;
	vec3 pos_futur;
	rotation_transform rot;
	hitbox bat_hitbox;

	// Timer used for the interpolation of the position
	cgp::timer_interval timer_mvt;

	// A helper structure used to store and display the key positions/time
	keyframe_structure keyframe;

	void initialize_mvt(vec3 p, numarray<vec3> key_positions, numarray<float> key_times);
	void update_mvt();
};